<?php

class TemplateApiVerticalTabsInputType extends TemplateApiInputType {
  public function form($input_definition, $input_values) {
    $form = array();

    $form['vertical_tabs'] = array(
      '#type' => 'vertical_tabs',
      '#title' => $input_definition['label'],
      '#collapsible' => FALSE,
      '#collapsed' => FALSE,
      '#tree' => TRUE,
    );

    foreach ($input_definition['children'] as $key=>$input) {
      $value = isset($input_values['vertical_tabs'][$key]) ? $input_values['vertical_tabs'][$key] : NULL;
      $form['vertical_tabs'][$key] = template_api_get_input_type_controller($input['type'])
        ->getForm($input, $value);
    }

    return $form;
  }

  public function getVariable($input_definition, $input_values) {
    $output = array();
    foreach ($input_values['vertical_tabs'] as $key => $value) {
      if (is_array($value)) {
        $input_type = $input_definition['children'][$key]['type'];
        $input_def = $input_definition['children'][$key];
        foreach ($value as $type => $input_value) {
          $output[$key] = template_api_get_input_type_controller($input_type)->getVariable($input_def, $value);
        }
      }
    }

    return $output;
  }

  public function isEmpty($input_definition, $input_values) {
    foreach ($input_values['vertical_tabs'] as $key => $value) {
      if (is_array($value)) {
        $input_type = $input_definition['children'][$key]['type'];
        $input_def = $input_definition['children'][$key];
        foreach ($value as $type => $input_value) {
          if (!template_api_get_input_type_controller($input_type)->isEmpty($input_def, $value)) {
            return FALSE;
          }
        }
      }
    }

    return TRUE;
  }
}